#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep 14 10:39:21 2020

@author: Lucia
"""
import numpy as np
import math

import vmf_test
import vmf_hollow_OD
import vmf_hollow_ID
import vmf_bisection
from utils_geo import *

# f2py -c name.f95 -m name

from scipy.spatial import distance

from scipy.optimize import minimize

#from mpl_toolkits.mplot2d import Axes3D
#from mpl_toolkits.mplot3d.art3d import Poly3DCollection, Line3DCollection
#import matplotlib.pyplot as plt

import time
import sys
import os
file = open('Radius.dat','a+')
file.close()
file = open('Density.dat','a+')
file.close()


def Geo_generator(name, rho, vfr, length, width, height, sb, Radius, vfraction, bow_h, bow_angle):
    if vfr=="a":
        if name =="92":
            print ("NOTE: geo 92 does not work with option a")
            sys.exit()
        print ("you chose to introduce volume fraction")

    if vfr=="b":
        print ("you chose to introduce radius")
    '''if(name=="2"):
        NumVolume = 29
        if(length+width+height>3):
            NumVolume = 1
    elif(name=="3"):
        NumVolume = 11
    elif(name=="9"):
        NumVolume = 19
    elif(name=="7"):
        NumVolume = 43'''

    A=[]
    B=[]
    x_cell=0
    y_cell=0
    z_cell=0
    r=0
    if name =="2": 
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
        if  vfr=="b":
            r=Radius
        A=A+[[[sb/2,0,sb/2],[0,sb/2,0],[r,0,0]],     	#0 
            [[sb/2,0,sb/2],[sb,sb/2,sb],[r,0,0]],    	#1
            [[sb/2,sb,sb/2],[0,1.5*sb,0],[r,0,0]],   	#15
            [[sb/2,sb,sb/2],[sb,1.5*sb,sb],[r,0,0]], 	#16
            [[sb,sb/2,0],[0,sb/2,sb],[r,0,0]],       	#17
   	    	    
            [[sb/2,0,sb/2],[sb,-sb/2,0],[r,0,0]],    	#2
            [[sb/2,0,sb/2],[0,-sb/2,sb],[r,0,0]],    	#3
            [[0,sb/2,0],[sb,sb/2,sb],[r,0,0]],       	#4
            [[sb/2,sb,sb/2],[sb,sb/2,0],[r,0,0]],    	#13
            [[sb/2,sb,sb/2],[0,sb/2,sb],[r,0,0]],    	#14	  
   	  
            [[0,sb/2,0],[-sb,sb/2,sb],[r,0,0]],  		#5
            [[0,sb/2,0],[-sb/2,sb,sb/2],[r,0,0]],		#6
            [[sb,sb/2,sb],[0,sb/2,2*sb],[r,0,0]],		#10
            [[sb,sb/2,sb],[1.5*sb,sb,sb/2],[r,0,0]],	#11
            [[sb,sb/2,sb],[2*sb,sb/2,0],[r,0,0]],   	#12  
            [[sb,sb/2,0],[sb/2,0,-sb/2],[r,0,0]],		#20
            [[sb,sb/2,0],[0,sb/2,-sb],[r,0,0]],		#21
            [[0,sb/2,sb],[sb/2,0,1.5*sb],[r,0,0]],		#22
 
            [[0,sb/2,0],[sb,sb/2,-sb],[r,0,0]],		#7
            [[0,sb/2,0],[sb/2,sb,-sb/2],[r,0,0]],		#8	
            [[sb,sb/2,sb],[sb/2,sb,1.5*sb],[r,0,0]],	#9	
            [[sb,sb/2,0],[1.5*sb,0,sb/2],[r,0,0]],		#18
            [[sb,sb/2,0],[2*sb,sb/2,sb],[r,0,0]],		#19
            [[0,sb/2,sb],[sb,sb/2,2*sb],[r,0,0]],		#23
            [[0,sb/2,sb],[-sb/2,0,sb/2],[r,0,0]],		#24
            [[0,sb/2,sb],[-sb,sb/2,0],[r,0,0]]]		#25

    elif name =="3":
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
        if  vfr=="b":
            r=Radius
        A=A+[[[0,0,0],[sb/2,sb/2,sb/2],[r,0,0]],		#0
            [[0,sb,0],[sb/2,sb/2,sb/2],[r,0,0]],		#2
            [[sb/2,sb/2,sb/2],[0,sb,sb],[r,0,0]],		#5
            [[sb/2,sb/2,sb/2],[0,0,sb],[r,0,0]],		#7
      
            [[sb,0,0],[sb/2,sb/2,sb/2],[r,0,0]],		#1
            [[sb,sb,0],[sb/2,sb/2,sb/2],[r,0,0]],		#3
            [[sb/2,sb/2,sb/2],[sb,sb,sb],[r,0,0]],	#4
            [[sb/2,sb/2,sb/2],[sb,0,sb],[r,0,0]]]		#6


    elif name== "4":
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
        if  vfr=="b":
            r=Radius

        A=A+[[[sb/4,sb/4,sb/4],[0,0,0],[r,0,0]],		     #0
            [[sb/4,sb/4,sb/4],[sb/2,sb/2,0],[r,0,0]],	     #1
            [[3.*sb/4,sb/4,sb/4],[sb,sb/2,sb/2],[r,0,0]],      #7
            [[3.*sb/4,3*sb/4,sb/4],[sb,sb/2,sb/2],[r,0,0]],    #11
            [[sb/4,3.*sb/4,sb/4],[0,sb,0],[r,0,0]],	     #12
            [[sb/4,3.*sb/4,sb/4],[sb/2,sb/2,0],[r,0,0]],	     #13
            [[sb/4,sb/4,3.*sb/4],[0,sb/2,sb/2],[r,0,0]],	     #19
            [[3*sb/4,sb/4,3.*sb/4],[sb,0,sb],[r,0,0]],	     #20
            [[3*sb/4,sb/4,3.*sb/4],[sb/2,sb/2,sb],[r,0,0]],    #21
            [[3*sb/4,3.*sb/4,3.*sb/4],[sb,sb,sb],[r,0,0]],     #24
            [[3*sb/4,3.*sb/4,3.*sb/4],[sb/2,sb/2,sb],[r,0,0]], #25
            [[sb/4,3.*sb/4,3.*sb/4],[0,sb/2,sb/2],[r,0,0]],    #31
             
            [[sb/4,sb/4,sb/4],[sb/2,0,sb/2],[r,0,0]],	     #2
            [[sb/4,sb/4,sb/4],[0,sb/2,sb/2],[r,0,0]],	     #3
            [[3.*sb/4,sb/4,sb/4],[sb,0,0],[r,0,0]],	     #4
            [[3.*sb/4,sb/4,sb/4],[sb/2,sb/2,0],[r,0,0]],	     #5
            [[3.*sb/4,sb/4,sb/4],[sb/2,0,sb/2],[r,0,0]],	     #6
            [[3.*sb/4,3*sb/4,sb/4],[sb,sb,0],[r,0,0]],	     #8 
            [[3.*sb/4,3*sb/4,sb/4],[sb/2,sb/2,0],[r,0,0]],     #9
            [[3.*sb/4,3*sb/4,sb/4],[sb/2,sb,sb/2],[r,0,0]],    #10
            [[sb/4,3.*sb/4,sb/4],[sb/2,sb,sb/2],[r,0,0]],      #14
            [[sb/4,3.*sb/4,sb/4],[0,sb/2,sb/2],[r,0,0]],	     #15 
            [[sb/4,sb/4,3.*sb/4],[0,0,sb],[r,0,0]],	     #16
            [[sb/4,sb/4,3.*sb/4],[sb/2,sb/2,sb],[r,0,0]],      #17
            [[sb/4,sb/4,3.*sb/4],[sb/2,0,sb/2],[r,0,0]],	     #18
            [[3*sb/4,sb/4,3.*sb/4],[sb/2,0,sb/2],[r,0,0]],     #22
            [[3*sb/4,sb/4,3.*sb/4],[sb,sb/2,sb/2],[r,0,0]],    #23
            [[3*sb/4,3.*sb/4,3.*sb/4],[sb/2,sb,sb/2],[r,0,0]], #26
            [[3*sb/4,3.*sb/4,3.*sb/4],[sb,sb/2,sb/2],[r,0,0]], #27
            [[sb/4,3.*sb/4,3*sb/4],[0,sb,sb],[r,0,0]],	     #28
            [[sb/4,3.*sb/4,3.*sb/4],[sb/2,sb/2,sb],[r,0,0]],   #29
            [[sb/4,3.*sb/4,3.*sb/4],[sb/2,sb,sb/2],[r,0,0]]]   #30

    elif name == "5":
 
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb

        if  vfr=="b":
            r=Radius 
    #angles: 56º and 45º
    #inner star points:

        s56_f=(sb/2)+((math.sin(math.radians(34))/math.sin(math.radians(56)))*sb/4)
        s56_c=(sb/2)-((math.sin(math.radians(34))/math.sin(math.radians(56)))*sb/4)

        A=[[[sb,3*sb/4,sb],[s56_f,3*sb/4,sb/2],[r,0,0]],	#2
            [[sb,3*sb/4,sb],[3*sb/4,sb/2,sb/2],[r,0,0]],	#3
            [[sb,sb/4,sb],[s56_f,sb/4,sb/2],[r,0,0]],	#6
            [[sb,sb/4,sb],[3*sb/4,sb/2,sb/2],[r,0,0]],	#7
            [[0,3*sb/4,0],[s56_c,3*sb/4,sb/2],[r,0,0]],	#8
            [[0,3*sb/4,0],[sb/4,sb/2,sb/2],[r,0,0]],   	#9
            [[0,sb/4,0],[s56_c,sb/4,sb/2],[r,0,0]],	#12
            [[0,sb/4,0],[sb/4,sb/2,sb/2],[r,0,0]],   	#13
            [[sb/2,0,0],[s56_c,sb/4,sb/2],[r,0,0]],	#16
            [[sb/2,0,0],[s56_f,sb/4,sb/2],[r,0,0]],	#17
            [[sb/2,sb,sb],[s56_c,3*sb/4,sb/2],[r,0,0]],	#22  
            [[sb/2,sb,sb],[s56_f,3*sb/4,sb/2],[r,0,0]],	#23
            [[sb/2,sb/2,0],[s56_f,3*sb/4,sb/2],[r,0,0]],  #24
            [[sb/2,sb/2,0],[s56_c,3*sb/4,sb/2],[r,0,0]],  #26      
            [[sb/2,sb/2,0],[3*sb/4,sb/2,sb/2],[r,0,0]],	#28       
            [[sb/2,sb/2,sb],[s56_f,sb/4,sb/2],[r,0,0]],	#31
            [[sb/2,sb/2,sb],[s56_c,sb/4,sb/2],[r,0,0]],	#33
            [[sb/2,sb/2,sb],[sb/4,sb/2,sb/2],[r,0,0]],	#35  
  
            [[sb,3*sb/4,0],[s56_f,3*sb/4,sb/2],[r,0,0]],  #0
            [[sb,3*sb/4,0],[3*sb/4,sb/2,sb/2],[r,0,0]],	#1     
            [[sb,sb/4,0],[s56_f,sb/4,sb/2],[r,0,0]],	#4
            [[sb,sb/4,0],[3*sb/4,sb/2,sb/2],[r,0,0]],	#5   
            [[0,3*sb/4,sb],[s56_c,3*sb/4,sb/2],[r,0,0]],	#10
            [[0,3*sb/4,sb],[sb/4,sb/2,sb/2],[r,0,0]],	#11
            [[0,sb/4,sb],[s56_c,sb/4,sb/2],[r,0,0]],	#14
            [[0,sb/4,sb],[sb/4,sb/2,sb/2],[r,0,0]],   	#15
            [[sb/2,0,sb],[s56_c,sb/4,sb/2],[r,0,0]],	#18
            [[sb/2,0,sb],[s56_f,sb/4,sb/2],[r,0,0]],	#19
            [[sb/2,sb,0],[s56_c,3*sb/4,sb/2],[r,0,0]],	#20
            [[sb/2,sb,0],[s56_f,3*sb/4,sb/2],[r,0,0]],	#21
            [[sb/2,sb/2,0],[s56_f,sb/4,sb/2],[r,0,0]],	#25
            [[sb/2,sb/2,0],[s56_c,sb/4,sb/2],[r,0,0]],	#27
            [[sb/2,sb/2,0],[sb/4,sb/2,sb/2],[r,0,0]],	#29
            [[sb/2,sb/2,sb],[s56_f,3*sb/4,sb/2],[r,0,0]], #30
            [[sb/2,sb/2,sb],[s56_c,3*sb/4,sb/2],[r,0,0]], #32
            [[sb/2,sb/2,sb],[3*sb/4,sb/2,sb/2],[r,0,0]]]	#34 

    elif name == "6":

        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
        if  vfr=="b":
            r=Radius
        A=[[[0,0,0],[sb,0,sb],[r,0,0]],
            [[0,0,sb],[sb,0,0],[r,0,0]],
            [[sb,0,sb],[sb,sb,0],[r,0,0]],
            [[sb,0,0],[sb,sb,sb],[r,0,0]],
            [[sb,sb,sb],[0,sb,0],[r,0,0]],
            [[0,sb,sb],[sb,sb,0],[r,0,0]],
            [[0,sb,sb],[0,0,0],[r,0,0]],
            [[0,0,sb],[0,sb,0],[r,0,0]],
            [[0,0,0],[sb,sb,0],[r,0,0]],
            [[sb,0,0],[0,sb,0],[r,0,0]],
            [[0,0,sb],[sb,sb,sb],[r,0,0]],
            [[sb,0,sb],[0,sb,sb],[r,0,0]],
            [[sb/2,0,sb/2],[sb,sb/2,sb/2],[r,0,0]],
            [[sb/2,0,sb/2],[0,sb/2,sb/2],[r,0,0]],   
            [[sb/2,0,sb/2],[sb/2,sb/2,0],[r,0,0]],
            [[sb/2,0,sb/2],[sb/2,sb/2,sb],[r,0,0]],
            [[sb/2,sb/2,0],[sb,sb/2,sb/2],[r,0,0]],
            [[sb/2,sb/2,0],[0,sb/2,sb/2],[r,0,0]],
            [[sb/2,sb/2,0],[sb/2,sb,sb/2],[r,0,0]],
            [[0,sb/2,sb/2],[sb/2,sb,sb/2],[r,0,0]],
            [[sb/2,sb,sb/2],[sb,sb/2,sb/2],[r,0,0]],
            [[sb/2,sb,sb/2],[sb/2,sb/2,sb],[r,0,0]],
            [[0,sb/2,sb/2],[sb/2,sb/2,sb],[r,0,0]],
            [[sb,sb/2,sb/2],[sb/2,sb/2,sb],[r,0,0]]]

    elif name== "7":
   
        y_cell=y_cell+sb
        z_cell=z_cell+sb

    #hexagon side lenght: l
    #hexagon side to side lenght: sb
    #lattice x lenght: l2

        l=(sb/2)/(math.sin(math.radians(60)))
        x_cell=3*l
    
        if  vfr=="b":
            r=Radius
        
        A=[[[l,sb,0],[2*l,sb,0],[r,0,0]],			#0
            [[l,0,0],[2*l,0,0],[r,0,0]],			#3
            [[2.5*l,sb/2,0],[3*l,sb/2,0],[r,0,0]],	#7
            [[2.5*l,sb/2,sb],[3*l,sb/2,sb],[r,0,0]],	#23
            [[l,sb,0],[l/2,sb/2,sb/2],[r,0,0]],		#24 
            [[2.5*l,sb/2,0],[2*l,sb,sb/2],[r,0,0]],	#29         
            [[l,0,sb],[l/2,sb/2,sb/2],[r,0,0]],		#32        
            [[2.5*l,sb/2,sb],[2*l,0,sb/2],[r,0,0]],	#34
            [[l/2,sb/2,sb/2],[-l/2,sb/2,0],[r,0,0]],	#38
            [[l/2,sb/2,sb/2],[-l/2,sb/2,sb],[r,0,0]],	#39         
                                   
            [[l,sb,0],[l/2,sb/2,0],[r,0,0]],		#1
            [[l/2,sb/2,0],[l,0,0],[r,0,0]],		#2
            [[2*l,0,0],[2.5*l,sb/2,0],[r,0,0]],		#4
            [[2.5*l,sb/2,0],[2*l,sb,0],[r,0,0]],		#5
        
            [[l,sb,sb/2],[l/2,sb/2,sb/2],[r,0,0]],	#9
            [[l/2,sb/2,sb/2],[l,0,sb/2],[r,0,0]],		#10
            [[2*l,0,sb/2],[2.5*l,sb/2,sb/2],[r,0,0]],	#12
            [[2.5*l,sb/2,sb/2],[2*l,sb,sb/2],[r,0,0]],	#13        
            [[l,sb,sb],[l/2,sb/2,sb],[r,0,0]],		#17
            [[l/2,sb/2,sb],[l,0,sb],[r,0,0]],		#18
            [[2*l,0,sb],[2.5*l,sb/2,sb],[r,0,0]],		#20
            [[2.5*l,sb/2,sb],[2*l,sb,sb],[r,0,0]],	#21        
        
        
               
            [[l/2,sb/2,0],[0,sb/2,0],[r,0,0]],		#6
            [[l,sb,sb/2],[2*l,sb,sb/2],[r,0,0]],		#8
            [[l,0,sb/2],[2*l,0,sb/2],[r,0,0]],		#11
            [[l/2,sb/2,sb/2],[0,sb/2,sb/2],[r,0,0]],	#14        
            [[3*l,sb/2,sb/2],[2.5*l,sb/2,sb/2],[r,0,0]],	#15 origin & end coordinates changed: meshing problems
            [[l,sb,sb],[2*l,sb,sb],[r,0,0]],		#16        
            [[l,0,sb],[2*l,0,sb],[r,0,0]],		#19
            [[l/2,sb/2,sb],[0,sb/2,sb],[r,0,0]],		#22          
        
            [[l,sb,0],[2*l,sb,sb/2],[r,0,0]],		#25
            [[l,0,0],[l/2,sb/2,sb/2],[r,0,0]],		#26
            [[l,0,0],[2*l,0,sb/2],[r,0,0]],		#27
            [[2.5*l,sb/2,0],[2*l,0,sb/2],[r,0,0]],	#28		  
            [[l,sb,sb],[l/2,sb/2,sb/2],[r,0,0]],		#30
            [[l,sb,sb],[2*l,sb,sb/2],[r,0,0]],		#31
            [[l,0,sb],[2*l,0,sb/2],[r,0,0]],		#33
            [[2.5*l,sb/2,sb],[2*l,sb,sb/2],[r,0,0]],	#35        
            [[2.5*l,sb/2,0],[3.5*l,sb/2,sb/2],[r,0,0]],	#36
            [[2.5*l,sb/2,sb],[3.5*l,sb/2,sb/2],[r,0,0]]]	#37


    elif name== "8":
    
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
    
        if  vfr=="b":
            r=Radius

    #bow height: bow_h
    #bow points: bow_p
    #middle point:(connection) tie_l
    #tie points:(connection) tie_p
    #angle of bow corner: bow_angle
    #f and c correspond to close and far from axis x,y,z
        
    #-------calculations
    
        tie_l=((math.sin(math.radians(90-bow_angle))/math.sin(math.radians(bow_angle)))*sb/2)
        bow_pc=(sb-bow_h)/2
        bow_pf=bow_h+bow_pc
        tie_pc=bow_pc+tie_l
        tie_pf=bow_pf-tie_l
    
    # only for B
        m=(bow_pc-tie_pc)/((sb)-(sb/2))
        pcortec=(sb/4)*m+bow_pc
        pcortef=(-sb/4)*m+bow_pf
        centrec=(-sb/10)*m+tie_pc
        centref=(sb/10)*m+tie_pf
    #-----------
    
    # A for vox and phase
    # B for mesh
    
        A=[[[tie_pc,sb/2,0],[0,sb/2,0],[r,0,0]],
            [[tie_pc,sb/2,0],[bow_pc,0,0],[r,0,0]],
            [[tie_pc,sb/2,0],[bow_pc,sb,0],[r,0,0]],
            [[tie_pf,sb/2,0],[sb,sb/2,0],[r,0,0]],
            [[tie_pf,sb/2,0],[bow_pf,0,0],[r,0,0]],
            [[tie_pf,sb/2,0],[bow_pf,sb,0],[r,0,0]],
            [[bow_pc,0,0],[bow_pf,0,0],[r,0,0]],
            [[bow_pc,sb,0],[bow_pf,sb,0],[r,0,0]],
            [[tie_pc,sb/2,sb],[0,sb/2,sb],[r,0,0]],
            [[tie_pc,sb/2,sb],[bow_pc,0,sb],[r,0,0]],
            [[tie_pc,sb/2,sb],[bow_pc,sb,sb],[r,0,0]],
            [[tie_pf,sb/2,sb],[sb,sb/2,sb],[r,0,0]],
            [[tie_pf,sb/2,sb],[bow_pf,0,sb],[r,0,0]],
            [[tie_pf,sb/2,sb],[bow_pf,sb,sb],[r,0,0]],
            [[bow_pc,0,sb],[bow_pf,0,sb],[r,0,0]],
            [[bow_pc,sb,sb],[bow_pf,sb,sb],[r,0,0]],
            [[sb/2,0,tie_pc],[sb/2,0,0],[r,0,0]],
            [[sb/2,0,tie_pc],[0,0,bow_pc],[r,0,0]],
            [[sb/2,0,tie_pc],[sb,0,bow_pc],[r,0,0]],
            [[sb/2,0,tie_pf],[sb/2,0,sb],[r,0,0]],
            [[sb/2,0,tie_pf],[0,0,bow_pf],[r,0,0]],
            [[sb/2,0,tie_pf],[sb,0,bow_pf],[r,0,0]],
            [[0,0,bow_pc],[0,0,bow_pf],[r,0,0]],
            [[sb,0,bow_pc],[sb,0,bow_pf],[r,0,0]],
            [[sb/2,sb,tie_pc],[sb/2,sb,0],[r,0,0]],
            [[sb/2,sb,tie_pc],[0,sb,bow_pc],[r,0,0]],
            [[sb/2,sb,tie_pc],[sb,sb,bow_pc],[r,0,0]],
            [[sb/2,sb,tie_pf],[sb/2,sb,sb],[r,0,0]],
            [[sb/2,sb,tie_pf],[0,sb,bow_pf],[r,0,0]],
            [[sb/2,sb,tie_pf],[sb,sb,bow_pf],[r,0,0]],
            [[0,sb,bow_pc],[0,sb,bow_pf],[r,0,0]],
            [[sb,sb,bow_pc],[sb,sb,bow_pf],[r,0,0]], 
            [[0,tie_pc,sb/2],[0,0,sb/2],[r,0,0]],
            [[0,tie_pc,sb/2],[0,bow_pc,0],[r,0,0]],
            [[0,tie_pc,sb/2],[0,bow_pc,sb],[r,0,0]],
            [[0,tie_pf,sb/2],[0,sb,sb/2],[r,0,0]],
            [[0,tie_pf,sb/2],[0,bow_pf,0],[r,0,0]],
            [[0,tie_pf,sb/2],[0,bow_pf,sb],[r,0,0]],
            [[0,bow_pc,0],[0,bow_pf,0],[r,0,0]],
            [[0,bow_pc,sb],[0,bow_pf,sb],[r,0,0]],
            [[sb,tie_pc,sb/2],[sb,0,sb/2],[r,0,0]],
            [[sb,tie_pc,sb/2],[sb,bow_pc,0],[r,0,0]],
            [[sb,tie_pc,sb/2],[sb,bow_pc,sb],[r,0,0]],
            [[sb,tie_pf,sb/2],[sb,sb,sb/2],[r,0,0]],
            [[sb,tie_pf,sb/2],[sb,bow_pf,0],[r,0,0]],
            [[sb,tie_pf,sb/2],[sb,bow_pf,sb],[r,0,0]],
            [[sb,bow_pc,0],[sb,bow_pf,0],[r,0,0]],
            [[sb,bow_pc,sb],[sb,bow_pf,sb],[r,0,0]]]
    

#-----------
        B=[[[tie_pc,sb/2,0],[0,sb/2,0],[r,0,0]],        
        [[tie_pf,sb/2,0],[sb,sb/2,0],[r,0,0]],          
        [[bow_pc,0,0],[bow_pf,0,0],[r,0,0]],
        [[bow_pc,sb,0],[bow_pf,sb,0],[r,0,0]],        
        [[tie_pc,sb/2,sb],[0,sb/2,sb],[r,0,0]],
        [[tie_pf,sb/2,sb],[sb,sb/2,sb],[r,0,0]],        
        [[bow_pc,0,sb],[bow_pf,0,sb],[r,0,0]],
        [[bow_pc,sb,sb],[bow_pf,sb,sb],[r,0,0]],       
        [[sb/2,0,tie_pc],[sb/2,0,0],[r,0,0]],
        [[sb/2,0,tie_pf],[sb/2,0,sb],[r,0,0]],          
        [[0,0,bow_pc],[0,0,bow_pf],[r,0,0]],
        [[sb,0,bow_pc],[sb,0,bow_pf],[r,0,0]],        
        [[sb/2,sb,tie_pc],[sb/2,sb,0],[r,0,0]],
        [[sb/2,sb,tie_pf],[sb/2,sb,sb],[r,0,0]],       
        [[0,sb,bow_pc],[0,sb,bow_pf],[r,0,0]],
        [[sb,sb,bow_pc],[sb,sb,bow_pf],[r,0,0]],         
        [[0,tie_pc,sb/2],[0,0,sb/2],[r,0,0]],
        [[0,tie_pf,sb/2],[0,sb,sb/2],[r,0,0]],       
        [[0,bow_pc,0],[0,bow_pf,0],[r,0,0]],
        [[0,bow_pc,sb],[0,bow_pf,sb],[r,0,0]],      
        [[sb,tie_pc,sb/2],[sb,0,sb/2],[r,0,0]],
        [[sb,tie_pf,sb/2],[sb,sb,sb/2],[r,0,0]],  
        [[sb,bow_pc,0],[sb,bow_pf,0],[r,0,0]],
        [[sb,bow_pc,sb],[sb,bow_pf,sb],[r,0,0]],
        
        [[centrec,sb/2+(sb/10),0],[pcortec,-sb/4,0],[r,0,0]],   
        [[centrec,sb/2-(sb/10),0],[pcortec,(sb+sb/4),0],[r,0,0]],
        [[centref,sb/2+(sb/10),0],[pcortef,-sb/4,0],[r,0,0]],
        [[centref,sb/2-(sb/10),0],[pcortef,(sb+sb/4),0],[r,0,0]],
        
        [[centrec,sb/2+(sb/10),sb],[pcortec,-sb/4,sb],[r,0,0]],   
        [[centrec,sb/2-(sb/10),sb],[pcortec,(sb+sb/4),sb],[r,0,0]],
        [[centref,sb/2+(sb/10),sb],[pcortef,-sb/4,sb],[r,0,0]],
        [[centref,sb/2-(sb/10),sb],[pcortef,(sb+sb/4),sb],[r,0,0]],
        
        [[sb/2+(sb/10),0,centrec],[-sb/4,0,pcortec],[r,0,0]],   
        [[sb/2-(sb/10),0,centrec],[(sb+sb/4),0,pcortec],[r,0,0]],
        [[sb/2+(sb/10),0,centref],[-sb/4,0,pcortef],[r,0,0]],
        [[sb/2-(sb/10),0,centref],[(sb+sb/4),0,pcortef],[r,0,0]],
        
        [[sb/2+(sb/10),sb,centrec],[-sb/4,sb,pcortec],[r,0,0]],   
        [[sb/2-(sb/10),sb,centrec],[(sb+sb/4),sb,pcortec],[r,0,0]],
        [[sb/2+(sb/10),sb,centref],[-sb/4,sb,pcortef],[r,0,0]],
        [[sb/2-(sb/10),sb,centref],[(sb+sb/4),sb,pcortef],[r,0,0]],
        
        [[0,centrec,sb/2+(sb/10)],[0,pcortec,-sb/4],[r,0,0]],   
        [[0,centrec,sb/2-(sb/10)],[0,pcortec,(sb+sb/4)],[r,0,0]],
        [[0,centref,sb/2+(sb/10)],[0,pcortef,-sb/4],[r,0,0]],
        [[0,centref,sb/2-(sb/10)],[0,pcortef,(sb+sb/4)],[r,0,0]],
        
        [[sb,centrec,sb/2+(sb/10)],[sb,pcortec,-sb/4],[r,0,0]],   
        [[sb,centrec,sb/2-(sb/10)],[sb,pcortec,(sb+sb/4)],[r,0,0]],
        [[sb,centref,sb/2+(sb/10)],[sb,pcortef,-sb/4],[r,0,0]],
        [[sb,centref,sb/2-(sb/10)],[sb,pcortef,(sb+sb/4)],[r,0,0]]]


    elif name== "9":

        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
    
        if  vfr=="b":
            r=Radius

        A=[[[sb/2,0,sb/2],[0,sb/2,sb/2],[r,0,0]],			#1
        [[sb/2,sb,sb/2],[sb,sb/2,sb/2],[r,0,0]],		#2
        [[sb/4,sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0]],	#4
        [[sb/4,sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0]],	#5
        [[sb/2,sb/2,0],[3*sb/4,sb/4,sb/2],[r,0,0]],		#10
        [[sb/2,sb/2,0],[3*sb/4,3*sb/4,sb/2],[r,0,0]],	#11
        [[sb/2,sb/2,sb],[sb/4,sb/4,sb/2],[r,0,0]],		#12
        [[sb/2,sb/2,sb],[sb/4,3*sb/4,sb/2],[r,0,0]],		#13        
        
        [[sb/2,0,sb/2],[sb, sb/2,sb/2],[r,0,0]],		#0
        [[sb/2,sb,sb/2],[0,sb/2,sb/2],[r,0,0]], 		#3
        [[3*sb/4,3*sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0]],	#6
        [[3*sb/4,3*sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0]], 	#7
        [[sb/2,sb/2,0],[sb/4,sb/4,sb/2],[r,0,0]],		#8
        [[sb/2,sb/2,0],[sb/4,3*sb/4,sb/2],[r,0,0]],		#9
        [[sb/2,sb/2,sb],[3*sb/4,sb/4,sb/2],[r,0,0]],		#14
        [[sb/2,sb/2,sb],[3*sb/4,3*sb/4,sb/2],[r,0,0]]]	#15


    elif name== "91":

        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
    
        if  vfr=="b":
            r=Radius  

        A=[[[sb/2,0,sb/2],[0,sb/2,sb/2],[r,0,0]],			#1
        [[sb/2,sb,sb/2],[sb,sb/2,sb/2],[r,0,0]],		#2
        [[sb/4,sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0]],	#4
        [[sb/4,sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0]],	#5
        [[sb/2,sb/2,0],[3*sb/4,sb/4,sb/2],[r,0,0]],		#10
        [[sb/2,sb/2,0],[3*sb/4,3*sb/4,sb/2],[r,0,0]],	#11
        [[sb/2,sb/2,sb],[sb/4,sb/4,sb/2],[r,0,0]],		#12
        [[sb/2,sb/2,sb],[sb/4,3*sb/4,sb/2],[r,0,0]],		#13
        [[0,0,sb/2],[0,sb,sb/2],[r,0,0]],			#16
        [[sb,0,sb/2],[sb,sb,sb/2],[r,0,0]],			#17        
        
        [[sb/2,0,sb/2],[sb, sb/2,sb/2],[r,0,0]],		#0
        [[sb/2,sb,sb/2],[0,sb/2,sb/2],[r,0,0]], 		#3
        [[3*sb/4,3*sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0]],	#6
        [[3*sb/4,3*sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0]], 	#7
        [[sb/2,sb/2,0],[sb/4,sb/4,sb/2],[r,0,0]],		#8
        [[sb/2,sb/2,0],[sb/4,3*sb/4,sb/2],[r,0,0]],		#9
        [[sb/2,sb/2,sb],[3*sb/4,sb/4,sb/2],[r,0,0]],		#14
        [[sb/2,sb/2,sb],[3*sb/4,3*sb/4,sb/2],[r,0,0]]]	#15
             

    elif name=="92":
        if  vfr=="b":           
            r=Radius    
        ri=r/1.25
        x_cell=x_cell+sb
        y_cell=y_cell+sb
        z_cell=z_cell+sb
    
        A=[[[sb/2,0,sb/2],[0,sb/2,sb/2],[r,0,0],[ri,0,0]],		#1
        [[sb/2,sb,sb/2],[sb,sb/2,sb/2],[r,0,0],[ri,0,0]],		#2
        [[sb/4,sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],	#4        
        [[sb/4,sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]],	#5        
        [[sb/2,sb/2,0],[3*sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],		#10
        [[sb/2,sb/2,0],[3*sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]],	#11
        [[sb/2,sb/2,sb],[sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],		#12
        [[sb/2,sb/2,sb],[sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]],	#13        
        
        [[sb/2,0,sb/2],[sb, sb/2,sb/2],[r,0,0],[ri,0,0]],		#0        
        [[sb/2,sb,sb/2],[0,sb/2,sb/2],[r,0,0],[ri,0,0]], 		#3
        [[3*sb/4,3*sb/4,sb/2],[3*sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],	#6
        [[3*sb/4,3*sb/4,sb/2],[sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]], 	#7
        [[sb/2,sb/2,0],[sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],		#8
        [[sb/2,sb/2,0],[sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]],		#9
        [[sb/2,sb/2,sb],[3*sb/4,sb/4,sb/2],[r,0,0],[ri,0,0]],	#14
        [[sb/2,sb/2,sb],[3*sb/4,3*sb/4,sb/2],[r,0,0],[ri,0,0]]]	#15


    elif name== "10":
    
        x_cell=x_cell+sb
        y_cell=y_cell+sb
    #z=0.5x and x=y
        l=sb/2
        z_cell=l
    
        if  vfr=="b":
            r=Radius
        
        A=[[[0,0,0],[0,sb,0],[r,0,0]],  #2			
        [[sb,0,0],[sb,sb,0 ],[r,0,0]],	#3	
        [[0,0,l],[0,sb,l],[r,0,0]],	       #11 	
        [[sb,0,l],[sb,sb,l],[r,0,0]],   #12
        [[sb/2,0,l/2],[sb/2,sb,l/2],[r,0,0]],	#8

        [[sb,sb,l],[0,0,0],[r,0,0]],	#4
        [[sb,sb,0],[0,0,-l],[r,0,0]],
        [[sb,sb,2*l],[0,0,l],[r,0,0]],
        [[2*sb,sb,l],[sb,0,0],[r,0,0]],
        [[0,sb,l],[-sb,0,0],[r,0,0]],

        [[0,sb,0],[sb,0,l],[r,0,0]],    #5
        [[0,sb,-l],[sb,0,0],[r,0,0]],
        [[0,sb,l],[sb,0,2*l],[r,0,0]],
        [[sb,sb,0],[2*sb,0,l],[r,0,0]],
        [[-sb,sb,0],[0,0,l],[r,0,0]],

        [[sb,sb/2,0],[sb/2,0,l/2],[r,0,0]], #6
        [[sb,sb/2,-l],[sb/2,0,-l/2],[r,0,0]],
        [[sb,sb/2,l],[sb/2,0,3*l/2],[r,0,0]],
        [[0,sb/2,0],[-sb/2,0,l/2],[r,0,0]],

        [[sb/2,sb,l/2],[sb,sb/2,0],[r,0,0]],  #7	
        [[sb/2,sb,-l/2],[sb,sb/2,-l],[r,0,0]],
        [[sb/2,sb,3*l/2],[sb,sb/2,l],[r,0,0]],
        [[-sb/2,sb,l/2],[0,sb/2,0],[r,0,0]],

        [[sb/2,0,l/2],[0,sb/2,l],[r,0,0]],		#9
        [[sb/2,0,-l/2],[0,sb/2,0],[r,0,0]],
        #[[sb/2,0,3*l/2],[0,sb/2,2*l],[r,0,0]],
        [[3*sb/2,0,l/2],[sb,sb/2,l],[r,0,0]],

        [[0,sb/2,l],[sb/2,sb,l/2],[r,0,0]], #10
        [[0,sb/2,0],[sb/2,sb,-l/2],[r,0,0]],
        #[[0,sb/2,2*l],[sb/2,sb,3*l/2],[r,0,0]],
        [[sb,sb/2,l],[3*sb/2,sb,l/2],[r,0,0]]]
  
    r0=r


    if  vfr=="a":
        
        voxelized(name, vfr, vfraction, rho, sb, x_cell,y_cell,z_cell,length, width,height, A, B)
        print ("7.a. Please introduce value of RADIUSf")
        with open('Radius.dat','r') as data:
            B_string = data.read()
        r0=float(B_string)
        mesh(name, vfr, vfraction, rho, sb, x_cell,y_cell,z_cell,length, width,height, A, B, r0)

    if  vfr=="b":
        mesh(name, vfr, vfraction, rho, sb, x_cell,y_cell,z_cell,length, width,height, A,B,r0)
        voxelized(name, vfr, vfraction, rho, sb, x_cell,y_cell,z_cell,length, width,height, A, B)  
     
    GeoFile = name+"_"+rho+".geo" 
    cl_min = str(r0*0.3)
    cl_max = str(r0*0.7)

    HeadLine="""Mesh.CharacteristicLengthMin =""" + cl_min + """;
Mesh.CharacteristicLengthMax =""" + cl_max + """;"""

    EndLine = """
Mytopx() = Surface In BoundingBox{Rx-e,-e,-e, Rx+e,Ry+e,Rz+e};
Mytopy() = Surface In BoundingBox{-e,Ry-e,-e, Rx+e,Ry+e,Rz+e};
Mytopz() = Surface In BoundingBox{-e,-e,Rz-e, Rx+e,Ry+e,Rz+e};

AllVol() = Volume{:};

Physical Surface(100) = {bottomx()};
Physical Surface(110) = {bottomy()};
Physical Surface(120) = {bottomz()};

Physical Surface(101) = {Mytopx()};
Physical Surface(111) = {Mytopy()};
Physical Surface(121) = {Mytopz()};

Physical Volume(51) ={AllVol()};"""
#Physical Volume(51) ={"""+str(NumVolume)+""",1};"""

    f = open(GeoFile, "r")
    contents = f.readlines()
    f.close()
    contents.insert(1, HeadLine)
    contents.append(EndLine)

    f = open(GeoFile, "w")
    contents = "".join(contents)
    f.write(contents)
    f.close()
    #os.system("rm vox_"+rho+".geo")
    #os.system("rm phase_map_"+rho+".geo")

    return GeoFile, r0


